<?php

namespace FiloBlu\Storelocator\Model\Plugin\Rma\Item;

use FiloBlu\Storelocator\Helper\Data;

class Status
{
    /**
     * @var Data
     */
    protected $helper;

    public function __construct(
        Data $helper
    )
    {
        $this->helper = $helper;
    }

    public function afterGetAllowedStatuses(\Magento\Rma\Model\Item\Status $subject, $result) {

        if (!$this->helper->getReturnToStoreEnabled()) {
            return $result;
        }

        if (in_array($subject->getStatus(), ['authorized', 'received', \FiloBlu\Storelocator\Model\Plugin\Rma\Source\Status::STATE_RECEIVED_IN_STORE])) {

            if (count($result)) {
                $result[\FiloBlu\Storelocator\Model\Plugin\Rma\Source\Status::STATE_RECEIVED_IN_STORE] = __(\FiloBlu\Storelocator\Model\Plugin\Rma\Source\Status::STATE_RECEIVED_IN_STORE_PHRASE);
            } else {
                $result = [
                    \Magento\Rma\Model\Item\Attribute\Source\Status::STATE_RECEIVED => ucfirst(\Magento\Rma\Model\Item\Attribute\Source\Status::STATE_RECEIVED),
                    \Magento\Rma\Model\Item\Attribute\Source\Status::STATE_APPROVED => ucfirst(\Magento\Rma\Model\Item\Attribute\Source\Status::STATE_APPROVED),
                    \Magento\Rma\Model\Item\Attribute\Source\Status::STATE_REJECTED => ucfirst(\Magento\Rma\Model\Item\Attribute\Source\Status::STATE_REJECTED),
                    \FiloBlu\Storelocator\Model\Plugin\Rma\Source\Status::STATE_RECEIVED_IN_STORE => \FiloBlu\Storelocator\Model\Plugin\Rma\Source\Status::STATE_RECEIVED_IN_STORE_PHRASE
                ];
            }

        }

        return $result;
    }

    public function afterGetAttributeIsEditable(\Magento\Rma\Model\Item\Status $subject, $result, $attribute = null) {
        if ($subject->getStatus() == \FiloBlu\Storelocator\Model\Plugin\Rma\Source\Status::STATE_RECEIVED_IN_STORE) {
            return true;
        }

        return $result;
    }
}